Given a non-empty string s and a dictionary WordDict containing a list of non-empty words, determine if s can be segmented into a space-separated sequence of one or more dictionary words. You may assume the dictionary does not contain duplicate words.
For example, given s = “leetcode”, dict = [“leet”, “code”].
Return true because “leetcode” can be segmented as “leet code”.
UPDATE (2017/1/4): The wordDict parameter had been changed to a list of strings (instead of a set of strings). Please reload the code definition to get the latest changes.
s思路: 1. 看到第一眼,想是不是要遍历所有可能的word break。例如:s = “leetcode”, 以”l”开头的一个一个查表看有没有”l”,”le”,”lee”,”leet”,刚好,发现有一个”leet”,然后recursive进入下一个层次找以”c”开头的单词了;看起来没毛病,但这只是故事的一部分。完整版本是,如果发现字典有”l”,”eet”,那么还可以通过遍历”l”和”eet”之后也进入到查找以”c”开头的单词是否可以在字典中找到。叙述到这里,也就是说判断以”c”开头的单词是否可以在字典中就要进行两次,也就是说,我们发现重复计算的情况出现。 2. 重复计算,那么就要用DP.每次计算好某一个位置起始是否可以做到word break, 把结果保存起来,一方便重复使用! 3. 瞄了一眼hint,用dp。之前有总结,如果判断是与非的问题,对整个问题的判断依靠对局部问题的判断,也就是:整个string要能break,那么其部分也应该可以break。这样的问题,就可以用dp,把大的问题划分成小的问题。 4. 再把自己粗糙的思路写一下:刚开始尝试用2d的DP来做,发现大部分地方是零,做起来很别扭;然后换成1d的DP来写,一下就顺畅了。给我的启发就是,确定dp后,不知道是用1d还是2d,那就都尝试一下,哪个写起来顺畅就是哪个。当然背后肯定有硬道理了。 5. 思考什么时候用1d,什么时候2d的DP?
//方法1:1d的DPclass Solution {public: bool wordBreak(string s, vector<string>& wordDict) { // int n=s.size(); vector<bool> dp(n,0); unordered_set<string> ss(wordDict.begin(),wordDict.end()); for(int i=0;i<n;i++){ //if(dp[i]==1) continue; //if(i==0||dp[i-1]==1&&dp[i]==0){//bug:只需要i-1是1即可! if(i==0||dp[i-1]==1){ for(int j=i;j<n;j++){ string cur=s.substr(i,j-i+1); if(ss.count(cur)) dp[j]=1; } } } return dp[n-1]; }};新闻热点
疑难解答